<?php

namespace App\Http\Controllers;

use App\Models\HorarioPreferencia;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class HorarioPreferenciaController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = HorarioPreferencia::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new HorarioPreferencia())->getFillable());
        $horarioPreferencia = HorarioPreferencia::create($payload);

        return response()->json([
            'success' => true,
            'data' => $horarioPreferencia,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(HorarioPreferencia $horarioPreferencia): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $horarioPreferencia,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, HorarioPreferencia $horarioPreferencia): JsonResponse
    {
        $payload = $request->only((new HorarioPreferencia())->getFillable());
        $horarioPreferencia->update($payload);

        return response()->json([
            'success' => true,
            'data' => $horarioPreferencia,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(HorarioPreferencia $horarioPreferencia): JsonResponse
    {
        $horarioPreferencia->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}